#include "resource.h"
#include <windows.h>
#include <commctrl.h>

char * pathStr = 0;

int getWinOwnerInfo(char * owner, DWORD ownLen, char * organiz, DWORD orgLen);
int setWinOwnerInfo(const char * owner, int ownLen, const char * organiz, int orgLen);

BOOL CALLBACK AboutDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam) {
switch(Message) {
	case WM_INITDIALOG:
	return TRUE;
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
		case IDOK:
		EndDialog(hwnd, IDOK);
		break;
	}
	break;
	case WM_CLOSE:
	EndDialog(hwnd, 0);
	break;
	default:
	return FALSE;
}
return TRUE;
}

BOOL CALLBACK MainDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam) {
switch(Message) {
	case WM_INITDIALOG:
	{
	SendMessage(hwnd, WM_SETICON, ICON_SMALL, (LPARAM)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAINICON), IMAGE_ICON, 16, 16, 0));
	SendMessage(hwnd, WM_SETICON, ICON_BIG, (LPARAM)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAINICON), IMAGE_ICON, 32, 32, 0));
	SendDlgItemMessage(hwnd, IDE_OWNER, EM_LIMITTEXT, (WPARAM)100, 0);
	SendDlgItemMessage(hwnd, IDE_ORGANIZATION, EM_LIMITTEXT, (WPARAM)100, 0);
	char own[101];
	char org[101];
	if(!getWinOwnerInfo(own, 101, org, 101)) break;
	SendDlgItemMessage(hwnd, IDE_OWNER, WM_SETTEXT, 0, (LPARAM)own);
	SendDlgItemMessage(hwnd, IDE_ORGANIZATION, WM_SETTEXT, 0, (LPARAM)org);
	}
	break;
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
		case IDB_SAVE:
		{
		int ownLen = SendDlgItemMessage(hwnd, IDE_OWNER, WM_GETTEXTLENGTH, 0, 0);
		int orgLen = SendDlgItemMessage(hwnd, IDE_ORGANIZATION, WM_GETTEXTLENGTH, 0, 0);
		char * owner = new char[ownLen + 1];
		char * organ = new char[orgLen + 1];
		SendDlgItemMessage(hwnd, IDE_OWNER, WM_GETTEXT, (WPARAM)(ownLen + 1), (LPARAM)owner);
		SendDlgItemMessage(hwnd, IDE_ORGANIZATION, WM_GETTEXT, (WPARAM)(orgLen + 1), (LPARAM)organ);
		setWinOwnerInfo(owner, ownLen, organ, orgLen);
		delete [] owner;
		delete [] organ;
		}
		break;
		case IDB_ABOUT:
		DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ABOUT), hwnd, AboutDlgProc);
		break;
		case IDB_EXIT:
		EndDialog(hwnd, 0);
		break;
	}
	break;
	case WM_CLOSE:
	EndDialog(hwnd, 0);
	break;
	default:
	return FALSE;
}
return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
OSVERSIONINFO ovi;
ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
GetVersionEx(&ovi);
switch (ovi.dwPlatformId) {
	case VER_PLATFORM_WIN32_WINDOWS:
	pathStr = new char[45];
	pathStr = "Software\\Microsoft\\Windows\\CurrentVersion";
	break;
	case VER_PLATFORM_WIN32_NT:
	pathStr = new char[48];
	pathStr = "Software\\Microsoft\\Windows NT\\CurrentVersion";
	break;
	default:
	MessageBox(NULL, "Operating System Not Supported!", "Error", MB_ICONEXCLAMATION | MB_OK);
	return 0;
	break;
}

InitCommonControls();

DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MAIN), NULL, MainDlgProc);
return 0;
}

int getWinOwnerInfo(char * owner, DWORD ownLen, char * organiz, DWORD orgLen) {
HKEY hkey;
if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, pathStr, 0, KEY_READ, &hkey) != ERROR_SUCCESS);
else if (RegQueryValueEx(hkey, "RegisteredOwner", 0, NULL, (BYTE *)owner, &ownLen) != ERROR_SUCCESS);
else if (RegQueryValueEx(hkey, "RegisteredOrganization", 0, NULL, (BYTE *)organiz, &orgLen) != ERROR_SUCCESS);
else if (RegCloseKey(hkey) != ERROR_SUCCESS);
else return 1;
return 0;
}

int setWinOwnerInfo(const char * owner, int ownLen, const char * organiz, int orgLen) {
HKEY hkey;
if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, pathStr, 0, KEY_WRITE, &hkey) != ERROR_SUCCESS);
else if (RegSetValueEx(hkey, "RegisteredOwner", 0, REG_SZ, (const BYTE *)owner, ownLen + 1) != ERROR_SUCCESS);
else if (RegSetValueEx(hkey, "RegisteredOrganization", 0, REG_SZ, (const BYTE *)organiz, orgLen + 1) != ERROR_SUCCESS);
else if (RegCloseKey(hkey) != ERROR_SUCCESS);
else {
MessageBox(NULL, "Write Owner Info Succeeded!", "Note", MB_ICONINFORMATION | MB_OK);
return 1;
}
MessageBox(NULL, "Write Owner Info Failed!", "Error", MB_ICONEXCLAMATION | MB_OK);
return 0;
}
